Index: openssl-1.1.0i/test/evp_test.c
===================================================================
--- openssl-1.1.0i.orig/test/evp_test.c
+++ openssl-1.1.0i/test/evp_test.c
@@ -18,6 +18,19 @@
 #include <openssl/pkcs12.h>
 #include <openssl/kdf.h>
 #include "internal/numbers.h"
+#include "testutil.h"
+
+int test_mem_eq(const char *file, int line, const char *st1, const char *st2,
+                const void *s1, size_t n1, const void *s2, size_t n2)
+{
+    if (s1 == NULL && s2 == NULL)
+        return 1;
+    if (n1 != n2 || s1 == NULL || s2 == NULL || memcmp(s1, s2, n1) != 0) {
+        return 0;
+    }
+    return 1;
+}
+
 
 /* Remove spaces from beginning and end of a string */
 
@@ -272,7 +285,7 @@ static const struct evp_test_method pver
 static const struct evp_test_method pderive_test_method;
 static const struct evp_test_method pbe_test_method;
 static const struct evp_test_method encode_test_method;
-static const struct evp_test_method kdf_test_method;
+static const struct evp_test_method kdf_test_method, pkey_kdf_test_method;
 static const struct evp_test_method keypair_test_method;
 
 static const struct evp_test_method *evp_test_list[] = {
@@ -287,6 +300,7 @@ static const struct evp_test_method *evp
     &pbe_test_method,
     &encode_test_method,
     &kdf_test_method,
+    &pkey_kdf_test_method,
     &keypair_test_method,
     NULL
 };
@@ -1962,7 +1976,7 @@ static const struct evp_test_method enco
 
 struct kdf_data {
     /* Context for this operation */
-    EVP_PKEY_CTX *ctx;
+    EVP_KDF_CTX *ctx;
     /* Expected output */
     unsigned char *output;
     size_t output_len;
@@ -1982,11 +1996,9 @@ static int kdf_test_init(struct evp_test
     kdata->ctx = NULL;
     kdata->output = NULL;
     t->data = kdata;
-    kdata->ctx = EVP_PKEY_CTX_new_id(OBJ_sn2nid(name), NULL);
+    kdata->ctx = EVP_KDF_CTX_new_id(OBJ_sn2nid(name));
     if (kdata->ctx == NULL)
         return 0;
-    if (EVP_PKEY_derive_init(kdata->ctx) <= 0)
-        return 0;
     return 1;
 }
 
@@ -1994,7 +2006,43 @@ static void kdf_test_cleanup(struct evp_
 {
     struct kdf_data *kdata = t->data;
     OPENSSL_free(kdata->output);
-    EVP_PKEY_CTX_free(kdata->ctx);
+    EVP_KDF_CTX_free(kdata->ctx);
+}
+
+static int kdf_test_ctrl(struct evp_test *t, EVP_KDF_CTX *kctx,
+                         const char *value)
+{
+    int rv;
+    char *p, *tmpval;
+
+    tmpval = OPENSSL_strdup(value);
+    if (tmpval == NULL)
+        return 0;
+    p = strchr(tmpval, ':');
+    if (p != NULL)
+        *p++ = '\0';
+    rv = EVP_KDF_ctrl_str(kctx, tmpval, p);
+    if (rv == -2) {
+        t->err = "KDF_CTRL_INVALID";
+        rv = 1;
+    } else if (p != NULL && rv <= 0) {
+        /* If p has an OID and lookup fails assume disabled algorithm */
+        int nid = OBJ_sn2nid(p);
+
+        if (nid == NID_undef)
+             nid = OBJ_ln2nid(p);
+        if (nid != NID_undef
+                && EVP_get_digestbynid(nid) == NULL
+                && EVP_get_cipherbynid(nid) == NULL) {
+            t->skip = 1;
+            rv = 1;
+        } else {
+            t->err = "KDF_CTRL_ERROR";
+            rv = 1;
+        }
+    }
+    OPENSSL_free(tmpval);
+    return rv > 0;
 }
 
 static int kdf_test_parse(struct evp_test *t,
@@ -2004,7 +2052,7 @@ static int kdf_test_parse(struct evp_tes
     if (strcmp(keyword, "Output") == 0)
         return test_bin(value, &kdata->output, &kdata->output_len);
     if (strncmp(keyword, "Ctrl", 4) == 0)
-        return pkey_test_ctrl(t, kdata->ctx, value);
+        return kdf_test_ctrl(t, kdata->ctx, value);
     return 0;
 }
 
@@ -2020,7 +2068,7 @@ static int kdf_test_run(struct evp_test
         exit(1);
     }
     err = "KDF_DERIVE_ERROR";
-    if (EVP_PKEY_derive(kdata->ctx, out, &out_len) <= 0)
+    if (EVP_KDF_derive(kdata->ctx, out, out_len) <= 0)
         goto err;
     err = "KDF_LENGTH_MISMATCH";
     if (out_len != kdata->output_len)
@@ -2043,6 +2091,108 @@ static const struct evp_test_method kdf_
     kdf_test_run
 };
 
+/**
+***  PKEY KDF TESTS
+**/
+
+typedef struct pkey_kdf_data_st {
+    /* Context for this operation */
+    EVP_PKEY_CTX *ctx;
+    /* Expected output */
+    unsigned char *output;
+    size_t output_len;
+} PKEY_KDF_DATA;
+
+/*
+ * Perform public key operation setup: lookup key, allocated ctx and call
+ * the appropriate initialisation function
+ */
+static int pkey_kdf_test_init(struct evp_test *t, const char *name)
+{
+    PKEY_KDF_DATA *kdata;
+    int kdf_nid = OBJ_sn2nid(name);
+
+#ifdef OPENSSL_NO_SCRYPT
+    if (strcmp(name, "scrypt") == 0) {
+        t->skip = 1;
+        return 1;
+    }
+#endif
+
+    if (kdf_nid == NID_undef)
+        kdf_nid = OBJ_ln2nid(name);
+
+    kdata = OPENSSL_zalloc(sizeof(*kdata));
+    if (kdata == NULL)
+        return 0;
+    kdata->ctx = EVP_PKEY_CTX_new_id(kdf_nid, NULL);
+    if (kdata->ctx == NULL) {
+        OPENSSL_free(kdata);
+        return 0;
+    }
+    if (EVP_PKEY_derive_init(kdata->ctx) <= 0) {
+        EVP_PKEY_CTX_free(kdata->ctx);
+        OPENSSL_free(kdata);
+        return 0;
+    }
+    t->data = kdata;
+    return 1;
+}
+
+static void pkey_kdf_test_cleanup(struct evp_test *t)
+{
+    PKEY_KDF_DATA *kdata = t->data;
+    OPENSSL_free(kdata->output);
+    EVP_PKEY_CTX_free(kdata->ctx);
+}
+
+static int pkey_kdf_test_parse(struct evp_test *t,
+                               const char *keyword, const char *value)
+{
+    PKEY_KDF_DATA *kdata = t->data;
+
+    if (strcmp(keyword, "Output") == 0)
+        return test_bin(value, &kdata->output, &kdata->output_len);
+    if (strncmp(keyword, "Ctrl", 4) == 0)
+        return pkey_test_ctrl(t, kdata->ctx, value);
+    return 0;
+}
+
+static int pkey_kdf_test_run(struct evp_test *t)
+{
+    PKEY_KDF_DATA *expected = t->data;
+    unsigned char *got = NULL;
+    size_t got_len = expected->output_len;
+
+    got = OPENSSL_malloc(got_len);
+    if (got == NULL) {
+        t->err = "INTERNAL_ERROR";
+        goto err;
+    }
+    if (EVP_PKEY_derive(expected->ctx, got, &got_len) <= 0) {
+        t->err = "KDF_DERIVE_ERROR";
+        goto err;
+    }
+    if (!TEST_mem_eq(expected->output, expected->output_len, got, got_len)) {
+        t->err = "KDF_MISMATCH";
+        goto err;
+    }
+    t->err = NULL;
+
+ err:
+    OPENSSL_free(got);
+    return 1;
+}
+
+static const struct evp_test_method pkey_kdf_test_method = {
+    "PKEYKDF",
+    pkey_kdf_test_init,
+    pkey_kdf_test_cleanup,
+    pkey_kdf_test_parse,
+    pkey_kdf_test_run
+};
+
+
 struct keypair_test_data {
     EVP_PKEY *privk;
     EVP_PKEY *pubk;
Index: openssl-1.1.0i/test/recipes/30-test_evp_kdf.t
===================================================================
--- /dev/null
+++ openssl-1.1.0i/test/recipes/30-test_evp_kdf.t
@@ -0,0 +1,13 @@
+#! /usr/bin/env perl
+# Copyright 2018 The OpenSSL Project Authors. All Rights Reserved.
+# Copyright (c) 2018, Oracle and/or its affiliates.  All rights reserved.
+#
+# Licensed under the Apache License 2.0 (the "License").  You may not use
+# this file except in compliance with the License.  You can obtain a copy
+# in the file LICENSE in the source distribution or at
+# https://www.openssl.org/source/license.html
+
+
+use OpenSSL::Test::Simple;
+
+simple_test("test_evp_kdf", "evp_kdf_test");
Index: openssl-1.1.0i/test/testutil.c
===================================================================
--- openssl-1.1.0i.orig/test/testutil.c
+++ openssl-1.1.0i/test/testutil.c
@@ -107,3 +107,15 @@ int strings_equal(const char *desc, cons
     }
     return 1;
 }
+
+int test_mem_eq(const char *file, int line, const char *st1, const char *st2,
+                const void *s1, size_t n1, const void *s2, size_t n2)
+{
+    if (s1 == NULL && s2 == NULL)
+        return 1;
+    if (n1 != n2 || s1 == NULL || s2 == NULL || memcmp(s1, s2, n1) != 0) {
+	fprintf(stderr, "memory not equal error:%s:%d\n",file, line);
+        return 0;
+    }
+    return 1;
+}
Index: openssl-1.1.0i/test/testutil.h
===================================================================
--- openssl-1.1.0i.orig/test/testutil.h
+++ openssl-1.1.0i/test/testutil.h
@@ -53,6 +53,17 @@
         return result
 
 /*
+ * Equality test for memory blocks where NULL is a legitimate value.
+ * These calls return 1 if the two memory blocks compare true.
+ * Otherwise, they return 0 and pretty-print diagnostics.
+ * These should not be called directly, use the TEST_xxx macros below instead.
+ */
+int test_mem_eq(const char *, int, const char *, const char *,
+                const void *, size_t, const void *, size_t);
+int test_mem_ne(const char *, int, const char *, const char *,
+                const void *, size_t, const void *, size_t);
+
+/*
  * TEST_CASE_NAME is defined as the name of the test case function where
  * possible; otherwise we get by with the file name and line number.
  */
@@ -109,3 +120,13 @@ int strings_equal(const char *desc, cons
             OPENSSL_assert(!#condition);        \
         }                                       \
     } while (0);
+
+
+/*
+ * TEST_error(desc, ...) prints an informative error message.
+ */
+#  define TEST_error(...)    fprintf(stderr, "Error: %s:%d:%s\n", __FILE__, __LINE__, __VA_ARGS__)
+/* #  define TEST_error(...)    test_error(__FILE__, __LINE__, __VA_ARGS__) */
+
+# define TEST_mem_eq(a, m, b, n) test_mem_eq(__FILE__, __LINE__, #a, #b, a, m, b, n)
+
Index: openssl-1.1.0i/util/libcrypto.num
===================================================================
--- openssl-1.1.0i.orig/util/libcrypto.num
+++ openssl-1.1.0i/util/libcrypto.num
@@ -4298,3 +4298,11 @@ X509_OBJECT_set1_X509
 X509_LOOKUP_meth_get_get_by_issuer_serial 4515	1_1_0i	EXIST::FUNCTION:
 X509_LOOKUP_meth_set_init               4516	1_1_0i	EXIST::FUNCTION:
 X509_OBJECT_set1_X509_CRL               4517	1_1_0i	EXIST::FUNCTION:
+EVP_KDF_CTX_new_id                      4518	1_1_0i	EXIST::FUNCTION:
+EVP_KDF_CTX_free                        4519	1_1_0i	EXIST::FUNCTION:
+EVP_KDF_reset                           4520	1_1_0i	EXIST::FUNCTION:
+EVP_KDF_ctrl                            4521	1_1_0i	EXIST::FUNCTION:
+EVP_KDF_vctrl                           4522	1_1_0i	EXIST::FUNCTION:
+EVP_KDF_ctrl_str                        4523	1_1_0i	EXIST::FUNCTION:
+EVP_KDF_size                            4524	1_1_0i	EXIST::FUNCTION:
+EVP_KDF_derive                          4525	1_1_0i	EXIST::FUNCTION:
Index: openssl-1.1.0i/crypto/kdf/sshkdf.c
===================================================================
--- /dev/null
+++ openssl-1.1.0i/crypto/kdf/sshkdf.c
@@ -0,0 +1,288 @@
+/*
+ * Copyright 2018-2018 The OpenSSL Project Authors. All Rights Reserved.
+ *
+ * Licensed under the OpenSSL license (the "License").  You may not use
+ * this file except in compliance with the License.  You can obtain a copy
+ * in the file LICENSE in the source distribution or at
+ * https://www.openssl.org/source/license.html
+ */
+
+#include <stdlib.h>
+#include <stdarg.h>
+#include <string.h>
+#include <openssl/evp.h>
+#include <openssl/kdf.h>
+#include "internal/cryptlib.h"
+#include "internal/evp_int.h"
+#include "kdf_local.h"
+
+/* See RFC 4253, Section 7.2 */
+
+static void kdf_sshkdf_reset(EVP_KDF_IMPL *impl);
+static int SSHKDF(const EVP_MD *evp_md,
+                  const unsigned char *key, size_t key_len,
+                  const unsigned char *xcghash, size_t xcghash_len,
+                  const unsigned char *session_id, size_t session_id_len,
+                  char type, unsigned char *okey, size_t okey_len);
+
+struct evp_kdf_impl_st {
+    const EVP_MD *md;
+    unsigned char *key; /* K */
+    size_t key_len;
+    unsigned char *xcghash; /* H */
+    size_t xcghash_len;
+    char type; /* X */
+    unsigned char *session_id;
+    size_t session_id_len;
+};
+
+static EVP_KDF_IMPL *kdf_sshkdf_new(void)
+{
+    EVP_KDF_IMPL *impl;
+
+    if ((impl = OPENSSL_zalloc(sizeof(*impl))) == NULL)
+        KDFerr(KDF_F_KDF_SSHKDF_NEW, ERR_R_MALLOC_FAILURE);
+    return impl;
+}
+
+static void kdf_sshkdf_free(EVP_KDF_IMPL *impl)
+{
+    kdf_sshkdf_reset(impl);
+    OPENSSL_free(impl);
+}
+
+static void kdf_sshkdf_reset(EVP_KDF_IMPL *impl)
+{
+    OPENSSL_clear_free(impl->key, impl->key_len);
+    OPENSSL_clear_free(impl->xcghash, impl->xcghash_len);
+    OPENSSL_clear_free(impl->session_id, impl->session_id_len);
+    memset(impl, 0, sizeof(*impl));
+}
+
+static int kdf_sshkdf_parse_buffer_arg(unsigned char **dst, size_t *dst_len,
+                                       va_list args)
+{
+    const unsigned char *p;
+    size_t len;
+
+    p = va_arg(args, const unsigned char *);
+    len = va_arg(args, size_t);
+    OPENSSL_clear_free(*dst, *dst_len);
+    *dst = OPENSSL_memdup(p, len);
+    if (*dst == NULL)
+        return 0;
+
+    *dst_len = len;
+    return 1;
+}
+
+static int kdf_sshkdf_ctrl(EVP_KDF_IMPL *impl, int cmd, va_list args)
+{
+    int t;
+
+    switch (cmd) {
+    case EVP_KDF_CTRL_SET_MD:
+        impl->md = va_arg(args, const EVP_MD *);
+        if (impl->md == NULL)
+            return 0;
+
+        return 1;
+
+    case EVP_KDF_CTRL_SET_KEY:
+        return kdf_sshkdf_parse_buffer_arg(&impl->key,
+                                           &impl->key_len, args);
+
+    case EVP_KDF_CTRL_SET_SSHKDF_XCGHASH:
+        return kdf_sshkdf_parse_buffer_arg(&impl->xcghash,
+                                           &impl->xcghash_len, args);
+
+    case EVP_KDF_CTRL_SET_SSHKDF_SESSION_ID:
+        return kdf_sshkdf_parse_buffer_arg(&impl->session_id,
+                                           &impl->session_id_len, args);
+
+    case EVP_KDF_CTRL_SET_SSHKDF_TYPE:
+        t = va_arg(args, int);
+        if (t < 65 || t > 70) {
+            KDFerr(KDF_F_KDF_SSHKDF_CTRL, KDF_R_VALUE_ERROR);
+            return 0;
+        }
+
+        impl->type = (char)t;
+        return 1;
+
+    default:
+        return -2;
+
+    }
+}
+
+static int kdf_sshkdf_ctrl_str(EVP_KDF_IMPL *impl, const char *type,
+                               const char *value)
+{
+    if (value == NULL) {
+        KDFerr(KDF_F_KDF_SSHKDF_CTRL_STR, KDF_R_VALUE_MISSING);
+        return 0;
+    }
+
+    if (strcmp(type, "md") == 0)
+        return kdf_md2ctrl(impl, kdf_sshkdf_ctrl, EVP_KDF_CTRL_SET_MD, value);
+
+    if (strcmp(type, "key") == 0)
+        return kdf_str2ctrl(impl, kdf_sshkdf_ctrl,
+                            EVP_KDF_CTRL_SET_KEY, value);
+
+    if (strcmp(type, "hexkey") == 0)
+        return kdf_hex2ctrl(impl, kdf_sshkdf_ctrl,
+                            EVP_KDF_CTRL_SET_KEY, value);
+
+    if (strcmp(type, "xcghash") == 0)
+        return kdf_str2ctrl(impl, kdf_sshkdf_ctrl,
+                            EVP_KDF_CTRL_SET_SSHKDF_XCGHASH, value);
+
+    if (strcmp(type, "hexxcghash") == 0)
+        return kdf_hex2ctrl(impl, kdf_sshkdf_ctrl,
+                            EVP_KDF_CTRL_SET_SSHKDF_XCGHASH, value);
+
+    if (strcmp(type, "session_id") == 0)
+        return kdf_str2ctrl(impl, kdf_sshkdf_ctrl,
+                            EVP_KDF_CTRL_SET_SSHKDF_SESSION_ID, value);
+
+    if (strcmp(type, "hexsession_id") == 0)
+        return kdf_hex2ctrl(impl, kdf_sshkdf_ctrl,
+                            EVP_KDF_CTRL_SET_SSHKDF_SESSION_ID, value);
+
+    if (strcmp(type, "type") == 0) {
+        if (strlen(value) != 1) {
+            KDFerr(KDF_F_KDF_SSHKDF_CTRL_STR, KDF_R_VALUE_ERROR);
+            return 0;
+        }
+
+        return call_ctrl(kdf_sshkdf_ctrl, impl, EVP_KDF_CTRL_SET_SSHKDF_TYPE,
+                         (int)value[0]);
+    }
+
+    KDFerr(KDF_F_KDF_SSHKDF_CTRL_STR, KDF_R_UNKNOWN_PARAMETER_TYPE);
+    return -2;
+}
+
+static size_t kdf_sshkdf_size(EVP_KDF_IMPL *impl)
+{
+    return SIZE_MAX;
+}
+
+static int kdf_sshkdf_derive(EVP_KDF_IMPL *impl, unsigned char *key,
+                             size_t keylen)
+{
+    if (impl->md == NULL) {
+        KDFerr(KDF_F_KDF_SSHKDF_DERIVE, KDF_R_MISSING_MESSAGE_DIGEST);
+        return 0;
+    }
+    if (impl->key == NULL) {
+        KDFerr(KDF_F_KDF_SSHKDF_DERIVE, KDF_R_MISSING_KEY);
+        return 0;
+    }
+    if (impl->xcghash == NULL) {
+        KDFerr(KDF_F_KDF_SSHKDF_DERIVE, KDF_R_MISSING_XCGHASH);
+        return 0;
+    }
+    if (impl->session_id == NULL) {
+        KDFerr(KDF_F_KDF_SSHKDF_DERIVE, KDF_R_MISSING_SESSION_ID);
+        return 0;
+    }
+    if (impl->type == 0) {
+        KDFerr(KDF_F_KDF_SSHKDF_DERIVE, KDF_R_MISSING_TYPE);
+        return 0;
+    }
+    return SSHKDF(impl->md, impl->key, impl->key_len,
+                  impl->xcghash, impl->xcghash_len,
+                  impl->session_id, impl->session_id_len,
+                  impl->type, key, keylen);
+}
+
+const EVP_KDF_METHOD sshkdf_kdf_meth = {
+    EVP_KDF_SSHKDF,
+    kdf_sshkdf_new,
+    kdf_sshkdf_free,
+    kdf_sshkdf_reset,
+    kdf_sshkdf_ctrl,
+    kdf_sshkdf_ctrl_str,
+    kdf_sshkdf_size,
+    kdf_sshkdf_derive,
+};
+
+static int SSHKDF(const EVP_MD *evp_md,
+                  const unsigned char *key, size_t key_len,
+                  const unsigned char *xcghash, size_t xcghash_len,
+                  const unsigned char *session_id, size_t session_id_len,
+                  char type, unsigned char *okey, size_t okey_len)
+{
+    EVP_MD_CTX *md = NULL;
+    unsigned char digest[EVP_MAX_MD_SIZE];
+    unsigned int dsize = 0;
+    size_t cursize = 0;
+    int ret = 0;
+
+    md = EVP_MD_CTX_new();
+    if (md == NULL)
+        return 0;
+
+    if (!EVP_DigestInit_ex(md, evp_md, NULL))
+        goto out;
+
+    if (!EVP_DigestUpdate(md, key, key_len))
+        goto out;
+
+    if (!EVP_DigestUpdate(md, xcghash, xcghash_len))
+        goto out;
+
+    if (!EVP_DigestUpdate(md, &type, 1))
+        goto out;
+
+    if (!EVP_DigestUpdate(md, session_id, session_id_len))
+        goto out;
+
+    if (!EVP_DigestFinal_ex(md, digest, &dsize))
+        goto out;
+
+    if (okey_len < dsize) {
+        memcpy(okey, digest, okey_len);
+        ret = 1;
+        goto out;
+    }
+
+    memcpy(okey, digest, dsize);
+
+    for (cursize = dsize; cursize < okey_len; cursize += dsize) {
+
+        if (!EVP_DigestInit_ex(md, evp_md, NULL))
+            goto out;
+
+        if (!EVP_DigestUpdate(md, key, key_len))
+            goto out;
+
+        if (!EVP_DigestUpdate(md, xcghash, xcghash_len))
+            goto out;
+
+        if (!EVP_DigestUpdate(md, okey, cursize))
+            goto out;
+
+        if (!EVP_DigestFinal_ex(md, digest, &dsize))
+            goto out;
+
+        if (okey_len < cursize + dsize) {
+            memcpy(okey + cursize, digest, okey_len - cursize);
+            ret = 1;
+            goto out;
+        }
+
+        memcpy(okey + cursize, digest, dsize);
+    }
+
+    ret = 1;
+
+out:
+    EVP_MD_CTX_free(md);
+    OPENSSL_cleanse(digest, EVP_MAX_MD_SIZE);
+    return ret;
+}
+
Index: openssl-1.1.0i/doc/man7/EVP_KDF_SSHKDF.pod
===================================================================
--- /dev/null
+++ openssl-1.1.0i/doc/man7/EVP_KDF_SSHKDF.pod
@@ -0,0 +1,175 @@
+=pod
+
+=head1 NAME
+
+EVP_KDF_SSHKDF - The SSHKDF EVP_KDF implementation
+
+=head1 DESCRIPTION
+
+Support for computing the B<SSHKDF> KDF through the B<EVP_KDF> API.
+
+The EVP_KDF_SSHKDF algorithm implements the SSHKDF key derivation function.
+It is defined in RFC 4253, section 7.2 and is used by SSH to derive IVs,
+encryption keys and integrity keys.
+Five inputs are required to perform key derivation: The hashing function
+(for example SHA256), the Initial Key, the Exchange Hash, the Session ID,
+and the derivation key type.
+
+=head2 Numeric identity
+
+B<EVP_KDF_SSHKDF> is the numeric identity for this implementation; it
+can be used with the EVP_KDF_CTX_new_id() function.
+
+=head2 Supported controls
+
+The supported controls are:
+
+=over 4
+
+=item B<EVP_KDF_CTRL_SET_MD>
+
+=item B<EVP_KDF_CTRL_SET_KEY>
+
+These controls work as described in L<EVP_KDF_CTX(3)/CONTROLS>.
+
+=item B<EVP_KDF_CTRL_SET_SSHKDF_XCGHASH>
+
+=item B<EVP_KDF_CTRL_SET_SSHKDF_SESSION_ID>
+
+These controls expect two arguments: C<unsigned char *buffer>, C<size_t length>
+
+They set the respective values to the first B<length> bytes of the buffer
+B<buffer>. If a value is already set, the contents are replaced.
+
+EVP_KDF_ctrl_str() takes two type strings for these controls:
+
+=over 4
+
+=item "xcghash"
+
+=item "session_id"
+
+The value string is used as is.
+
+=item "hexxcghash"
+
+=item "hexsession_id"
+
+The value string is expected to be a hexadecimal number, which will be
+decoded before being passed on as the control value.
+
+=back
+
+=item B<EVP_KDF_CTRL_SET_SSHKDF_TYPE>
+
+This control expects one argument: C<int mode>
+
+Sets the type for the SSHHKDF operation. There are six supported types:
+
+=over 4
+
+=item EVP_KDF_SSHKDF_TYPE_ININITAL_IV_CLI_TO_SRV
+
+The Initial IV from client to server.
+A single char of value 65 (ASCII char 'A').
+
+=item EVP_KDF_SSHKDF_TYPE_ININITAL_IV_SRV_TO_CLI
+
+The Initial IV from server to client
+A single char of value 66 (ASCII char 'B').
+
+=item EVP_KDF_SSHKDF_TYPE_ENCRYPTION_KEY_CLI_TO_SRV
+
+The Encryption Key from client to server
+A single char of value 67 (ASCII char 'C').
+
+=item EVP_KDF_SSHKDF_TYPE_ENCRYPTION_KEY_SRV_TO_CLI
+
+The Encryption Key from server to client
+A single char of value 68 (ASCII char 'D').
+
+=item EVP_KDF_SSHKDF_TYPE_INTEGRITY_KEY_CLI_TO_SRV
+
+The Integrity Key from client to server
+A single char of value 69 (ASCII char 'E').
+
+=item EVP_KDF_SSHKDF_TYPE_INTEGRITY_KEY_SRV_TO_CLI
+
+The Integrity Key from client to server
+A single char of value 70 (ASCII char 'F').
+
+=back
+
+EVP_KDF_ctrl_str() type string: "type"
+
+The value is a string of length one character. The only valid values
+are the numerical values of the ASCII caracters: "A" (65) to "F" (70).
+
+=back
+
+=head1 NOTES
+
+A context for SSHKDF can be obtained by calling:
+
+ EVP_KDF_CTX *kctx = EVP_KDF_CTX_new_id(EVP_KDF_SSHKDF);
+
+The output length of the SSHKDF derivation is specified via the C<keylen>
+parameter to the L<EVP_KDF_derive(3)> function.
+Since the SSHKDF output length is variable, calling L<EVP_KDF_size()>
+to obtain the requisite length is not meaningful. The caller must
+allocate a buffer of the desired length, and pass that buffer to the
+L<EVP_KDF_derive(3)> function along with the desired length.
+
+=head1 EXAMPLE
+
+This example derives an 8 byte IV using SHA-256 with a 1K "key" and appropriate
+"xcghash" and "session_id" values:
+
+ EVP_KDF_CTX *kctx;
+ unsigned char key[1024] = "01234...";
+ unsigned char xcghash[32] = "012345...";
+ unsigned char session_id[32] = "012345...";
+ unsigned char out[8];
+ size_t outlen = sizeof(out);
+ kctx = EVP_KDF_CTX_new_id(EVP_KDF_SSHKDF);
+
+ if (EVP_KDF_CTX_set_md(kctx, EVP_sha256()) <= 0)
+     /* Error */
+ if (EVP_KDF_CTX_set1_key(kctx, key, 1024) <= 0)
+     /* Error */
+ if (EVP_KDF_CTX_set1_sshkdf_xcghash(kctx, xcghash, 32) <= 0)
+     /* Error */
+ if (EVP_KDF_CTX_set1_sshkdf_session_id(kctx, session_id, 32) <= 0)
+     /* Error */
+ if (EVP_KDF_CTX_set_sshkdf_type(kctx,
+                    EVP_KDF_SSHKDF_TYPE_ININITAL_IV_CLI_TO_SRV) <= 0)
+     /* Error */
+ if (EVP_KDF_derive(kctx, out, &outlen) <= 0)
+     /* Error */
+
+
+=head1 CONFORMING TO
+
+RFC 4253
+
+=head1 SEE ALSO
+
+L<EVP_KDF_CTX>,
+L<EVP_KDF_CTX_new_id(3)>,
+L<EVP_KDF_CTX_free(3)>,
+L<EVP_KDF_ctrl(3)>,
+L<EVP_KDF_size(3)>,
+L<EVP_KDF_derive(3)>,
+L<EVP_KDF_CTX(3)/CONTROLS>
+
+=head1 COPYRIGHT
+
+Copyright 2016-2018 The OpenSSL Project Authors. All Rights Reserved.
+
+Licensed under the OpenSSL license (the "License").  You may not use
+this file except in compliance with the License.  You can obtain a copy
+in the file LICENSE in the source distribution or at
+L<https://www.openssl.org/source/license.html>.
+
+=cut
+
Index: openssl-1.1.0i/include/openssl/obj_mac.h
===================================================================
--- openssl-1.1.0i.orig/include/openssl/obj_mac.h
+++ openssl-1.1.0i/include/openssl/obj_mac.h
@@ -4486,6 +4486,10 @@
 #define LN_hkdf         "hkdf"
 #define NID_hkdf                1036
 
+#define SN_sshkdf               "SSHKDF"
+#define LN_sshkdf               "sshkdf"
+#define NID_sshkdf              1061
+
 #define SN_id_pkinit            "id-pkinit"
 #define NID_id_pkinit           1031
 #define OBJ_id_pkinit           1L,3L,6L,1L,5L,2L,3L
